#!/bin/bash


##lopsy.sh by ahs3
##Released under the GPL http://www.gnu.org/licenses/gpl.txt
## Not all of these Variables are used with lopsy, this script is used with many maps



xmax=14 ## this would be the max divided by 10 so '30=300'
div=20 ## replacement for minspace
ymax=8
minspace=10 #minimum space between objects to change this you must change xmax and ymax
ocount=16 ##max number of objects
map=sides.bzw #map name
slide=1 #this is the slide factor on the physics
death=5 #this is the number of object with death applied 
tankspeed=200 #tankspeed
shotspeed=225 #shotspeed
jumpvelocity=2 #jumpvelocity
wall=http://images.bzflag.org/astevens/ahs3_stone.png #texture for outside walls
radarlimit=1000 #radar limit
zmin=3
zmax=18
rotlev=45


function zsize {

zsize=$[ ( $RANDOM % 5 )   ]


}


function xrandom {
         
xnumber=$[ (( $RANDOM % $xmax ) * $div)   ]

}

function yrandom {
         
ynumber=$[ (( $RANDOM % $ymax ) * $div)   ]

}


function rot {
         
rot=$[ ( $RANDOM % $rotlev )   ]

}


function color {

let color=($RANDOM % 2)

}


function type1 {

let type1=($RANDOM % 1)

}

function pnx {

let pnx=($RANDOM % 3)

}



function pny {

let pny=($RANDOM % 3) 

}

rm $map

echo -e "define sides\n" >> $map
CNT=0

while [ $CNT -lt $ocount ]; do

yrandom
xrandom
color
type1
pnx
pny
rot
zsize

let zsize=($zsize + 1)

case $type1 in
0)
echo -e "\nbox" >> $map
;;
1)
echo -e "\npyramid" >> $map
;;
2)
echo -e "\narc" >> $map
;;
3)
echo -e "\ncone" >> $map
;;
*)
echo -e "\nbox" >> $map
;;
esac

case $pnx in

0)
echo -e "object generation\n"
pgx="+"
;;
1)
echo -e "object generation\n"
pgx="-"
;;
esac

case $pny in

0)
echo -e "object generation\n"
pgy="+"
;;
1)
echo -e "object generation\n"
pgy="-"
;;
esac



echo -e "\npos $pgx$xnumber $pgy$ynumber 0" >> $map

case $type1 in

0)
echo -e "\n size 10 10 5" >> $map
;;
1)

echo -e "\n size 5 5 10" >> $map
;;
2)
echo -e "\n size 20 20 $zsize" >> $map
echo -e "\n divisions 6" >> $map
;;
3)
echo -e "\n size 5 5 10" >> $map
echo -e "\n divisions 9" >> $map
;;
4)
echo -e "\n size 20 20 12" >> $map
;;
*)
echo -e "\n size 10 75 1 \n \npos $pgx$xnumber $pgy$ynumber 20  \n" >> $map
esac

if [ $type1 -eq 5 ]; then

echo -e " \n diffuse saddlebrown \n" >> $map

fi

#echo -e "\n texture roof" >> $map
echo -e "\n rotation $rot" >> $map
echo -e "\n end" >> $map

let CNT=CNT+1


done

echo -e "enddef ##sides \n" >> $map

echo -e "group sides \n shift -50 181 0 \n rotation 0 \n end \n" >> $map

echo -e "group sides \n shift 50 -181 -5 \n rotation 0 \n spin 180 0 1 0\n rotation 180\nend \n" >> $map


#cnt=0

#while [ $cnt -lt $death ]; do
#yrandom
#xrandom
#pnx
#pny

#case $pnx in

#0)
#echo -e "object generation\n"
#pgx="+"
#;;
#1)
#echo -e "object generation\n"
#pgx="-"
#;;
#esac

#case $pny in

#0)
#echo -e "object generation\n"
#pgy="+"
#;;
#1)
#echo -e "object generation\n"
#pgy="-"
#;;
#esac


#echo -e "box\n" >> $map
#echo -e "\npos $pgx$xnumber $pgy$ynumber 0" >> $map
#echo -e "size 5 5 100\n matref caution\n phydrv death \nend" >> $map
#let cnt=cnt+1
#done

yrandom
xrandom
color

echo "$xnumber is the X $ynumber is Y and $color is the color"
